:start
CLS
@setlocal Enableextensions EnableDelayedExpansion
@echo off
echo.
echo This batch program will create the needed aircraft.txt text file
echo for the compiler.
echo The name will be...MY_[folder]_AIRCRAFT_FILE_[#].TXT
echo.
echo It will create the AC#, Speed,Title and Vertical Default.
echo You'll need to open the file in excel and incert and then add three columns
echo between Your titles and the Vertical default.
echo That is;   Aircraft Ceiling, Aircraft Range and Runway Length required.
echo I've included a text file with that data for most aircraft.
echo.
echo You'll need to search the web for any types not listed.
echo.
echo  This Program will search in the default SimObjects directory.
echo.
echo  Just press enter for the default folder (airplanes) to search there.
echo.
echo  Or enter any other aircraft folder under the SimObjects folder.
echo.
set /p pathe=Folder= %=%
if "%pathe%"=="" set pathe=airplanes
set pathd=%pathe%
set pathd=%pathd:\="\"%
set pathd=%pathd::"\"=:\"%
set pathd="%pathd%"



::..............................Create Directory List

set path1="c:\"Program Files (x86)"\"Microsoft Games"\"Microsoft Flight Simulator X"\SimObjects\!pathd!\*"
set path2="c:\"Program Files"\"Microsoft Games"\"Microsoft Flight Simulator X"\SimObjects\!pathd!\*"



if exist "%path1%" for /d  %%d in ("%path1%") do (
@echo "%%d\aircraft.cfg">> lista.txt
)

if exist "%path2%" for /d  %%d in ("%path2%") do (
@echo "%%d\aircraft.cfg">> lista.txt
)


if exist "%path1%" goto makebat
if exist "%path2%" goto makebat

goto nopath


:makebat
for /f "tokens=*" %%d in (lista.txt) do (
set line=%%d
call :makelist1 "%%d"
)
goto createbat

:makelist1

IF not exist !line! goto :eof
@echo !line!>> list1.txt
goto :eof

:createbat
del lista.txt

MD files\

::...................................Create Bat files From List 1

set /A batcount=0
for /f "delims=|" %%d  in (list1.txt) do (
set line=%%d
call :bat "%%d"
)
goto bat2

:bat
@echo find /v "" !line!>> files\"!batcount!".bat
set /A batcount+=1
goto :eof

:bat2
del list1.txt

::..............Run bat files and create The Aircraft Cfg Files

set /A txtcount=0
:make
call files\"!txtcount!".bat>> files\"!txtcount!".txt
set /A txtcount+=1
if !txtcount!==!batcount! goto bat3
goto make

::............Clean TABs set fltsim charactors to lower case........

:bat3
@CLS
echo.
echo.
echo.
echo    Please Wait. . . . . . Creating Temp Aircraft config Files
echo.
set /A txtcount=0

:cleantabs
IF !txtcount!==!batcount! goto getlines
for /f "tokens=*" %%d in (files\!txtcount!.txt) do (
set line=%%d
call :fltsim "%%d%"
@echo !line!>> files\A!txtcount!.txt
)
goto fltsim2

:fltsim
set line1=!line!
set line1=!line:~0,7!
set line1=!line1:F=f!
set line1=!line1:I=i!
set line1=!line1:L=l!
set line1=!line1:M=m!
set line1=!line1:S=s!
set line1=!line1:T=t!
IF !line1!==[fltsim set line=!line1!
goto :eof



:fltsim2


set /A txtcount+=1
goto cleantabs

::...........Create Aircraft List Files 1,2,3.........

:getlines

set /A airnumber=1000
set  /A count2=0
set /A count3=0
set /A count4=0
set /A txtcount=0
set planes[]=0
set speed=

:nexttext

for /f "tokens=*" %%d in (files\A!txtcount!.txt) do (
set myline=%%d
call :plane "%%d%"
)
goto checkcount

:plane

set myline1=!myline:~0,7!

IF !myline1!==[fltsim set /A count2+=1
IF !myline1!==[fltsim set /A count3+=1
IF !myline1!==[fltsim goto :eof

IF !count2!==1 set planes[!count3!]=!myline!
set count2=0

goto :eof



::.............Loop and do next text File..........


:checkcount


for /f "tokens=*" %%a in ('findstr /I /B "cruise_speed" files\A!txtcount!.txt') do (
set speed=%%a
)
IF "%speed%"=="" set speed=cruise_speed_100
set count4=1
set speed=!speed:	=!
set speed=!speed: =!
set speed=!speed:~13,3!
IF !speed! lss 30 set speed=100
set check=!speed:~2,1!
IF !check!==0 set /A count4=2
IF !check!==1 set /A count4=2
IF !check!==2 set /A count4=2
IF !check!==3 set /A count4=2
IF !check!==4 set /A count4=2
IF !check!==5 set /A count4=2
IF !check!==6 set /A count4=2
IF !check!==7 set /A count4=2
IF !check!==8 set /A count4=2
IF !check!==9 set /A count4=2
IF !count4!==1 set speed=!speed:~0,2!
IF !count4!==2 set speed=!speed:~0,3!
set speed=!speed: =!


for /f "tokens=*" %%a in ('findstr /I /B "default_vertical_speed" files\A!txtcount!.txt') do (
set vert=%%a
) 
IF "%vert%"=="" set vert=default_vertical_speed_500



set count4=1
IF !count4!==1 set vert=!vert:	=!
IF !count4!==1 set vert=!vert: =!
IF !count4!==1 set vert=!vert:~23,4!
IF !vert! lss 100 set vert=500
set check=!vert:~3,1!
IF !check!==0 set /A count4=2
IF !check!==1 set /A count4=2
IF !check!==2 set /A count4=2
IF !check!==3 set /A count4=2
IF !check!==4 set /A count4=2
IF !check!==5 set /A count4=2
IF !check!==6 set /A count4=2
IF !check!==7 set /A count4=2
IF !check!==8 set /A count4=2
IF !check!==9 set /A count4=2
IF !count4!==1 set vert=!vert:~0,3!
IF !count4!==2 set vert=!vert:~0,4!
set vert=!vert: =!




set /A txtcount+=1
set /A airnumber+=10
set /A len=!count3!+1"
set  /a count3=1
:loop
@echo AC#!airnumber!,!speed!>> aircraft1.txt
@echo !planes[%count3%]!>> aircraft2.txt
@echo !vert!>> aircraft3.txt
set /a count3+=1
if %count3% neq %len% goto loop
)
set vert=
set speed=
set planes[]=
set /A count2=0
set /A count3=0
set /A count4=0

IF !batcount!==!txtcount! goto bat5

@CLS
echo.
echo.
echo.
echo    Please Wait. . . . . . Creating Temp Aircraft Text Files
echo.

goto nexttext





::..................Clean and merge text Files.......

:bat5

@CLS
echo.
echo.
echo.
echo    Please Wait. . .Finalizing and creating Aircraft Text File...
echo.






for /f "tokens=1* delims= " %%a in (aircraft1.txt) do (
@echo %%a>> aircraft1a.txt
)

for /f "tokens=1* delims= " %%a in (aircraft3.txt) do (
@echo %%a>> aircraft3a.txt
)

for /f "tokens=1,2 delims=="  %%d in (aircraft2.txt) do (
set line1=%%e
@echo !line1!>> aircraft4.txt
)


for /f "tokens=*"  %%d in (aircraft4.txt) do (
set line1=%%d
@echo !line1!>> aircraft5.txt
)


set f1=aircraft1a.txt
set f2=aircraft5.txt

(
for /f "delims=" %%a in (%f1%) do (
set /p line=
@echo %%a,!line!>> aircraft6.txt
 )
)<%f2%

set /A n=1
set pathe=!pathe: =_!
set pathe=!pathe:\=_!

:another

set path3=MY_!pathe!_FOLDER_AIRCRAFT_FILE_!n!.TXT
IF not exist !path3! goto finish
IF exist !path3! set /A n+=1
goto another
  

:finish



set f1=aircraft6.txt
set f2=aircraft3a.txt


(
for /f "delims=" %%a in (%f1%) do (
set /p line=
@echo %%a,!line!>> MY_!pathe!_FOLDER_AIRCRAFT_FILE_!n!.TXT
 )
)<%f2%






RD /S /Q files
del aircraft1a.txt
del aircraft3a.txt
del aircraft1.txt
del aircraft2.txt
del aircraft3.txt
del aircraft4.txt
del aircraft5.txt
del aircraft6.txt
echo.
echo.
echo .................DONE!
echo.
echo.
pause
endlocal


exit
 
:nopath

echo.
echo.
echo                   Path does not exist.
echo.
echo      
pause
endlocal
goto start
exit
